#!/usr/bin/python
# -*- coding: utf-8 -*-

import os
import zlib
from array import array
import shutil

#FILE = "seadogs.c"
#DSTPATH = "seadogs.c"

FILE = "init_pc.c"
DSTPATH = "CONTROLS\\init_pc.c"

shutil.copy('stormex2.dll', 'stormex2.dll.bak')
f = open('stormex2.dll.bak', 'rb')
f.seek(-24, os.SEEK_END)
fathdr = array('l');
fathdr.fromfile(f, 6)

offset, size = fathdr[2], fathdr[4]

f.seek(offset)

hdr = []

while size > 0:
	arr = array('l')
	arr.fromfile(f, 1)
	namelen = arr[0]
	size = size - namelen - 20
	filename = f.read(namelen)
	arr = array('l')
	arr.fromfile(f, 4)
	hdr.append((arr[2], arr[0], filename))
#	print "%s %d %d" % (filename, arr[0], arr[2])


f1 = open(FILE, 'rb')
new_data = f1.read()
f1.close()

oldhdr = sorted(hdr, key = lambda x: x[0])

def get_copy(fname, length):
    f = open(fname, 'rb')
    data = f.read(length)
    f.close()
    f = open(fname, 'wb')
    f.write(data)
    return f

dstf = get_copy('stormex2.dll', oldhdr[0][0])
dstf.seek(0, os.SEEK_END)

hdr = []
delta = 0
for i in range(0, len(oldhdr)):
	f.seek(oldhdr[i][0])
	if i == len(oldhdr) - 1:
		length = offset - oldhdr[i][0]
	else:
		length = oldhdr[i + 1][0] - oldhdr[i][0]
	if oldhdr[i][2] == DSTPATH:
		hdr.append((dstf.tell(), len(new_data), DSTPATH))
		delta = len(new_data) - length
		dstf.write(zlib.compress(new_data, 9))
		print 'Файл найден'
	else:
		hdr.append((dstf.tell(), oldhdr[i][1], oldhdr[i][2]))
		data = f.read(length)
		dstf.write(data)
f.close()

hdrpos = dstf.tell()
for h in hdr:
#	print h[2]
	dstf.write(array('l', [len(h[2])]).tostring())
	dstf.write(h[2])
	dstf.write(array('l', [h[1], 0, h[0], 0]).tostring())

dstf.write(array('l', [fathdr[0], fathdr[1], hdrpos, fathdr[3], fathdr[4], fathdr[5]]).tostring())
dstf.close()

print "patched :)"
