#!/usr/bin/python
# -*- coding: utf-8 -*-

import os
import zlib
from array import array

DESTINATION_DIR = "extracted/"

f = open('stormex2.dll', 'rb')
f.seek(-24, os.SEEK_END)
fathdr = array('l');
fathdr.fromfile(f, 6)

offset, size = fathdr[2], fathdr[4]
print "%x %x" % (offset, size)

f.seek(offset)

f1 = open('stormex2.dll', 'rb')

while size > 0:
	arr = array('l')
	arr.fromfile(f, 1)
	fnamelen = arr[0]
	size = size - fnamelen - 20
	filename = f.read(fnamelen)
	arr = array('l')
	arr.fromfile(f, 4)

	print "%x %x %x %x" % (arr[0], arr[1], arr[2], arr[3])
	filesize = 10 * 1024 * 1024 #arr[0]
	fileoffset = arr[2]

	print filename
	f1.seek(fileoffset)
	data = f1.read(filesize)

	filename = DESTINATION_DIR + filename.replace('\\', '/')
	path = filename[:filename.rfind('/')]
	if len(path) > 0:
		if not os.path.exists(path):
			os.makedirs(path)

	decompressed = zlib.decompress(data)
	if arr[0] != len(decompressed):
		print "ERROR!!!"

	df = open(filename, 'wb')
	df.write(decompressed)
	df.close()

f.close()
f1.close()
